package com.usky.agbox.service.listener;

import com.alibaba.fastjson.JSONObject;
import com.usky.agbox.service.job.patrolAgbox;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.core.ExchangeTypes;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class RabbitMQListener {
    @Autowired
    private patrolAgbox PatrolAgbox;
    @RabbitHandler
    @RabbitListener(bindings = @QueueBinding(
            value = @Queue(),
            exchange = @Exchange(value = "Patrol_FEvent",type = ExchangeTypes.FANOUT)
    ))
    public void getData(Message message){
        try {
            String str = new String(message.getBody(),"utf-8");
            JSONObject eventVO1 = JSONObject.parseObject(str);
            JSONObject eventVO = new JSONObject();
            String timeWithT = eventVO1.get("createTime").toString();
            eventVO.put("deviceId",eventVO1.get("deviceId"));
            eventVO.put("triggerTime",timeWithT.replace("T", " "));
            if (eventVO1.get("eventType").equals(31)){
                eventVO.put("eventCode",1);
            }else if (eventVO1.get("eventType").equals(32)){
                eventVO.put("eventCode",2);
            }else {
                eventVO.put("eventCode",16);
            }
            eventVO.put("name",eventVO1.get("createBy"));
            eventVO.put("certifiedNo","");
            PatrolAgbox.addEvent(eventVO.toJSONString());
            System.out.println("FEventReceiver消费者收到消息： " + str);
        } catch (Exception e){
            e.printStackTrace();
        }
    }

    @RabbitHandler
    @RabbitListener(bindings = @QueueBinding(
            value = @Queue(),
            exchange = @Exchange(value = "Patrol_FInfo",type = ExchangeTypes.FANOUT)
    ))
    public void getDataInfo(Message message){
        try {
            String str = new String(message.getBody(),"utf-8");
            JSONObject eventVO1 = JSONObject.parseObject(str);
            JSONObject eventVO = new JSONObject();
            eventVO.put("deviceId",eventVO1.get("deviceId"));
            PatrolAgbox.updateHeart(eventVO.toJSONString());
            System.out.println("FInfoReceiver消费者收到消息： " + str);
        } catch (Exception e){
            e.printStackTrace();
        }
    }
}